/*
 * This file was automaticly generated by clo++ version 0.60
 * http://pmade.org/pjones/software/clo++/
 */

/** @file
 * This file contains the implementation of the parser class.
 * You can control the name of this source file using the
 * cxx_source_file variable.
**/

#include "clo.h"
#include <cstring>
#include <cstdlib>
#include <cctype>
#include <libtpt/compat.h>

namespace {
    const char const_usage[] =
"  --cgiheader           Print a basic CGI header\n"
"  -I, --include string  Specify an alternate include directory\n"
"  -c, --check           Perform syntax checking only\n"
"  -v, --version         Display the version string\n"
"  -w, --warnings        Enable error reporting\n";

    const char* expand_long_name (const std::string &name);
}

//#########################################################################
clo::parser::parser (void)
    : state_(state_option)
{
    std::memset(&locations_, 0, sizeof(locations_));
}
//#########################################################################
void clo::parser::parse (int argc, char *argv[], bool call_finalize) {
    for (int i=1; i<argc; ++i) parse_element(argv[i], i, source_cl);
    if (call_finalize) finalize();
}
//#########################################################################
void clo::parser::finalize (void) {
    if (state_ == state_value) {
	switch (openum_) {
	    case option_cgiheader:
		throw clo::exception("missing value for 'cgiheader' option");
	    case option_check:
		throw clo::exception("missing value for 'check' option");
	    case option_include:
		throw clo::exception("missing value for 'include' option");
	    case option_version:
		throw clo::exception("missing value for 'version' option");
	    case option_warnings:
		throw clo::exception("missing value for 'warnings' option");
	}

    }

}
//#########################################################################
void clo::parser::parse_element (const char *element, int position, opsource source) {
    std::size_t length = std::strlen(element);

    switch (state_) {
	case state_consume:
	    non_options_.push_back(element);
	    break;
	case state_option:
	    if (length >= 2 && element[0] == '-' && element[1] == '-') {
		if (length == 2) { state_ = state_consume; return; }
		element += 2;
		const char *value = element;
		while (*value != 0 && *value != '=') ++value;
		if (*value == '=') {
		    std::string selement(element, value - element), svalue(++value);

		    parse_long_option(selement.c_str(), position, source);
		    if (state_ != state_value) {
			std::string error("the '"); error += element; error += "' option does not take a value";
			throw clo::exception(error);
		    }

		    parse_value(svalue.c_str());
		    state_ = state_option;
		} else {
		    parse_long_option(element, position, source);
		}
	    } else if (length >= 2 && element[0] == '-') {
		++element;

		if (length > 2) {
		    while (*element != 0) {
			parse_short_option(*element, position, source);
			++element;
	    
			if (state_ == state_value && *element != 0) {
			    parse_value(element);
			    state_ = state_option;
			    break;
			}
		    }
		} else {
		    parse_short_option(*element, position, source);
		}
	    } else {
		non_options_.push_back(element);
	    }
	    break;
	case state_value:
	    parse_value(element);
	    state_ = state_option;
	    break;
    }
}
//#########################################################################
void clo::parser::parse_short_option (char option, int position, opsource source) {
    switch (option) {
    	case 'I':
    	    openum_ = option_include;
    	    state_ = state_value;
    	    locations_.include = position;
    	    return;
    	case 'c':
    	    openum_ = option_check;
    	    options_.check = !options_.check;
    	    locations_.check = position;
    	    return;
    	case 'v':
    	    openum_ = option_version;
    	    options_.version = !options_.version;
    	    locations_.version = position;
    	    return;
    	case 'w':
    	    openum_ = option_warnings;
    	    options_.warnings = !options_.warnings;
    	    locations_.warnings = position;
    	    return;
    	case 'h':
    	    throw clo::autoexcept(autothrow_help, const_usage);
    	case '?':
    	    throw clo::autoexcept(autothrow_help, const_usage);
    }

    std::string error("unknown option: '"); error += option; error += "'";
    throw clo::exception(error);
}
//#########################################################################
void clo::parser::parse_long_option (const char *option, int position, opsource source) {
    option = expand_long_name(option);

	    if (std::strcmp(option, "cgiheader") == 0) {
		openum_ = option_cgiheader;
		locations_.cgiheader = position;
		options_.cgiheader = !options_.cgiheader;
		return;
	    } else if (std::strcmp(option, "check") == 0) {
		openum_ = option_check;
		locations_.check = position;
		options_.check = !options_.check;
		return;
	    } else if (std::strcmp(option, "include") == 0) {
		openum_ = option_include;
		locations_.include = position;
		state_ = state_value;
		return;
	    } else if (std::strcmp(option, "version") == 0) {
		openum_ = option_version;
		locations_.version = position;
		options_.version = !options_.version;
		return;
	    } else if (std::strcmp(option, "warnings") == 0) {
		openum_ = option_warnings;
		locations_.warnings = position;
		options_.warnings = !options_.warnings;
		return;
	    } else if (std::strcmp(option, "help") == 0) {
		throw clo::autoexcept(autothrow_help, const_usage);
	    }

    std::string error("unknown option '"); error += option; error += "'";
    throw clo::exception(error);
}
//#########################################################################
void clo::parser::parse_value (const char *value) {
    switch (openum_) {
    	case option_cgiheader:
	    break;
    	case option_check:
	    break;
    	case option_include:
    	    {
    		options_.include.push_back(value);
    	    }
	    break;
    	case option_version:
	    break;
    	case option_warnings:
	    break;
    }
}
//#########################################################################
namespace {
    const char* expand_long_name (const std::string &name) {
	std::string::size_type name_size = name.size();
	std::vector<const char*> matches;

        if (name_size <= 9 && name.compare(0, name_size, "cgiheader", name_size) == 0)
        	matches.push_back("cgiheader");

        if (name_size <= 5 && name.compare(0, name_size, "check", name_size) == 0)
        	matches.push_back("check");

        if (name_size <= 7 && name.compare(0, name_size, "include", name_size) == 0)
        	matches.push_back("include");

        if (name_size <= 7 && name.compare(0, name_size, "version", name_size) == 0)
        	matches.push_back("version");

        if (name_size <= 8 && name.compare(0, name_size, "warnings", name_size) == 0)
        	matches.push_back("warnings");

        if (name_size <= 4 && name.compare(0, name_size, "help", name_size) == 0)
        	matches.push_back("help");


	if (matches.empty()) {
	    std::string error("unknown option '"); error += name; error += "'";
	    throw clo::exception(error);
	}

	if (matches.size() == 1) {
	    return matches[0];
	}

	std::string error("the option name '"); error += name; error += "' is ambiguous";
	throw clo::exception(error);
    }
} // end anonymous namespace
